


#include "HIVE_CppPlugin.h"


NS_HIVE_BEGIN


std::string Configuration::getConfiguration()
{
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getConfiguration");
    
    picojson::value resJson = HiveCppPlugin::callNative(jsonParam);
    
    picojson::value jsonValue = resJson.get("getConfiguration");
    if(jsonValue.is<picojson::null>())
        return "";
//    return jsonValue.to_str();
    return jsonValue.serialize(true);
}


std::string Configuration::getHiveSDKVersion()
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getHiveSDKVersion");

	picojson::value resJson = HiveCppPlugin::callNative(jsonParam);

    picojson::value jsonValue = resJson.get("getHiveSDKVersion");
    if(jsonValue.is<picojson::null>())
        return "";
    return jsonValue.to_str();
}


std::string Configuration::getReferenceSDKVersion()
{
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getReferenceSDKVersion");
    
    picojson::value resJson = HiveCppPlugin::callNative(jsonParam);
    
    picojson::value jsonValue = resJson.get("getReferenceSDKVersion");
    if(jsonValue.is<picojson::null>())
        return "";
    return jsonValue.to_str();
}


std::string Configuration::getAppId()
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getAppId");

	picojson::value resJson = HiveCppPlugin::callNative(jsonParam);

    picojson::value jsonValue = resJson.get("getAppId");
    if(jsonValue.is<picojson::null>())
        return "";
    return jsonValue.to_str();
}


void Configuration::setAppId(std::string appId)
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setAppId");
	jsonParam["setAppId"] = picojson::value(appId);

	HiveCppPlugin::callNative(jsonParam);
}


ZoneType Configuration::getZone()
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getZone");

	picojson::value resJson = HiveCppPlugin::callNative(jsonParam);

    std::string resultValue;
    picojson::value jsonValue = resJson.get("getZone");
    if(jsonValue.is<picojson::null>() == false)
        resultValue = jsonValue.to_str();

    if(resultValue.compare("TEST") == 0)
		return ZoneType::TEST;
	else if(resultValue.compare("REAL") == 0)
		return ZoneType::REAL;
    else if(resultValue.compare("DEV") == 0)
        return ZoneType::DEV;
	else
		return ZoneType::SANDBOX;
}


void Configuration::setZone(ZoneType zone)
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setZone");

	std::string zoneString = "SANDBOX";
	if(zone == ZoneType::TEST)
		zoneString = "TEST";
	else if(zone == ZoneType::REAL)
		zoneString = "REAL";
    else if(zone == ZoneType::DEV)
        zoneString = "DEV";
	jsonParam["setZone"] = picojson::value(zoneString);

	HiveCppPlugin::callNative(jsonParam);
}


std::string Configuration::getServerId()
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getServerId");

	picojson::value resJson = HiveCppPlugin::callNative(jsonParam);

    picojson::value jsonValue = resJson.get("getServerId");
    if(jsonValue.is<picojson::null>())
        return "";
    return jsonValue.to_str();
}


void Configuration::setServerId(std::string serverId)
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setServerId");
	jsonParam["setServerId"] = picojson::value(serverId);

	HiveCppPlugin::callNative(jsonParam);
}


void Configuration::setGameLanguage(std::string language)
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setGameLanguage");
	jsonParam["setGameLanguage"] = picojson::value(language);

	HiveCppPlugin::callNative(jsonParam);
}


bool Configuration::getUseLog()
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getUseLog");

	picojson::value resJson = HiveCppPlugin::callNative(jsonParam);

    picojson::value jsonValue = resJson.get("getUseLog");
    if(jsonValue.is<picojson::null>())
        return false;
    return jsonValue.get<bool>();
}


void Configuration::setUseLog(bool useLog)
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setUseLog");
	jsonParam["setUseLog"] = picojson::value(useLog);

	HiveCppPlugin::callNative(jsonParam);
}


std::string Configuration::getCompany()
{
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getCompany");
    
    picojson::value resJson = HiveCppPlugin::callNative(jsonParam);
    
    picojson::value jsonValue = resJson.get("getCompany");
    if(jsonValue.is<picojson::null>())
        return "";
    return jsonValue.to_str();
}


void Configuration::setCompany(std::string company)
{
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setCompany");
    jsonParam["setCompany"] = picojson::value(company);
    
    HiveCppPlugin::callNative(jsonParam);
}


std::string Configuration::getChannel()
{
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getChannel");
    
    picojson::value resJson = HiveCppPlugin::callNative(jsonParam);
    
    picojson::value jsonValue = resJson.get("getChannel");
    if(jsonValue.is<picojson::null>())
        return "";
    return jsonValue.to_str();
}


void Configuration::setChannel(std::string channel)
{
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setChannel");
    jsonParam["setChannel"] = picojson::value(channel);
    
    HiveCppPlugin::callNative(jsonParam);
}


int Configuration::getHttpConnectTimeout()
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getHttpConnectTimeout");

	picojson::value resJson = HiveCppPlugin::callNative(jsonParam);

    picojson::value jsonValue = resJson.get("getHttpConnectTimeout");
    if(jsonValue.is<picojson::null>())
        return 15;
    return (int)jsonValue.get<double>();
}


void Configuration::setHttpConnectTimeout(int httpConnectTimeout)
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setHttpConnectTimeout");
	jsonParam["setHttpConnectTimeout"] = picojson::value((double)httpConnectTimeout);

	HiveCppPlugin::callNative(jsonParam);
}


int Configuration::getHttpReadTimeout()
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getHttpReadTimeout");

	picojson::value resJson = HiveCppPlugin::callNative(jsonParam);

    picojson::value jsonValue = resJson.get("getHttpReadTimeout");
    if(jsonValue.is<picojson::null>())
        return 10;
    return (int)jsonValue.get<double>();
}


void Configuration::setHttpReadTimeout(int httpReadTimeout)
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setHttpReadTimeout");
	jsonParam["setHttpReadTimeout"] = picojson::value((double)httpReadTimeout);

	HiveCppPlugin::callNative(jsonParam);
}


int Configuration::getMaxGameLogSize()
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getMaxGameLogSize");

	picojson::value resJson = HiveCppPlugin::callNative(jsonParam);

    picojson::value jsonValue = resJson.get("getMaxGameLogSize");
    if(jsonValue.is<picojson::null>())
        return 5;
    return (int)jsonValue.get<double>();
}


void Configuration::setMaxGameLogSize(int maxGameLogSize)
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setMaxGameLogSize");
	jsonParam["setMaxGameLogSize"] = picojson::value((double)maxGameLogSize);

	HiveCppPlugin::callNative(jsonParam);
}


std::string Configuration::getMarket()
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getMarket");

	picojson::value resJson = HiveCppPlugin::callNative(jsonParam);

    picojson::value jsonValue = resJson.get("getMarket");
    if(jsonValue.is<picojson::null>())
        return "";
    return jsonValue.to_str();
}

std::string Configuration::getHiveCountry() {
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getHiveCountry");
    
    picojson::value resJson = HiveCppPlugin::callNative(jsonParam);
    
    picojson::value jsonValue = resJson.get("getHiveCountry");
    if(jsonValue.is<picojson::null>())
        return "";
    return jsonValue.to_str();
}

void Configuration::setMarket(std::string market)
{
	picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setMarket");
	jsonParam["setMarket"] = picojson::value(market);

	HiveCppPlugin::callNative(jsonParam);
}

unsigned int Configuration::getAnalyticsSendLimit() {
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getAnalyticsSendLimit");
    
    picojson::value resJson = HiveCppPlugin::callNative(jsonParam);
    
    picojson::value jsonValue = resJson.get("getAnalyticsSendLimit");
    if(jsonValue.is<picojson::null>())
        return 0;
    return static_cast<unsigned int>(jsonValue.get<double>());
    
}

void Configuration::setAnalyticsSendLimit(unsigned int limit) {
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setAnalyticsSendLimit");
    jsonParam["setAnalyticsSendLimit"] = picojson::value(static_cast<double>(limit));
    
    HiveCppPlugin::callNative(jsonParam);
}

unsigned int Configuration::getAnalyticsQueueLimit() {
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getAnalyticsQueueLimit");
    
    picojson::value resJson = HiveCppPlugin::callNative(jsonParam);
    
    picojson::value jsonValue = resJson.get("getAnalyticsQueueLimit");
    if(jsonValue.is<picojson::null>())
        return 0;
    return static_cast<unsigned int>(jsonValue.get<double>());
    
}
void Configuration::setAnalyticsQueueLimit(unsigned int limit) {
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setAnalyticsQueueLimit");
    jsonParam["setAnalyticsQueueLimit"] = picojson::value(static_cast<double>(limit));
    
    HiveCppPlugin::callNative(jsonParam);
}

float Configuration::getAnalyticsSendCycleSeconds() {
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getAnalyticsSendCycleSeconds");
    
    picojson::value resJson = HiveCppPlugin::callNative(jsonParam);
    
    picojson::value jsonValue = resJson.get("getAnalyticsSendCycleSeconds");
    if(jsonValue.is<picojson::null>())
        return 0;
    return static_cast<float>(jsonValue.get<double>());
    
}

void Configuration::setAnalyticsSendCycleSeconds(float seconds) {
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setAnalyticsSendCycleSeconds");
    jsonParam["setAnalyticsSendCycleSeconds"] = picojson::value(seconds);
    
    HiveCppPlugin::callNative(jsonParam);
}

bool Configuration::getAgeGateU13() {
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getAgeGateU13");
    
    picojson::value resJson = HiveCppPlugin::callNative(jsonParam);
    
    picojson::value jsonValue = resJson.get("getAgeGateU13");
    if(jsonValue.is<picojson::null>())
        return false;
    
    return jsonValue.get<bool>();
}


void Configuration::setAgeGateU13(bool ageGateU13) {
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setAgeGateU13");
    jsonParam["setAgeGateU13"] = picojson::value(ageGateU13);
    
    HiveCppPlugin::callNative(jsonParam);
}

void Configuration::setHivePermissionViewOn(bool isOn) {
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "setHivePermissionViewOn");
    jsonParam["isOn"] = picojson::value(isOn);
    HiveCppPlugin::callNative(jsonParam);
}

PermissionViewData Configuration::getPermissionViewData(HIVELanguage language) {
    picojson::object jsonParam = HiveCppPlugin::createParam("Configuration", "getPermissionViewData");

    std::string languageStr = "";

    if (language == HIVELanguage::HIVELanguageDE) {
        languageStr = "de";
    }
    else if (language == HIVELanguage::HIVELanguageEN) {
        languageStr = "en";
    }
    else if (language == HIVELanguage::HIVELanguageES) {
        languageStr = "es";
    }
    else if (language == HIVELanguage::HIVELanguageFR) {
        languageStr = "fr";
    }
    else if (language == HIVELanguage::HIVELanguageID) {
        languageStr = "id";
    }
    else if (language == HIVELanguage::HIVELanguageIT) {
        languageStr = "it";
    }
    else if (language == HIVELanguage::HIVELanguageJA) {
        languageStr = "ja";
    }
    else if (language == HIVELanguage::HIVELanguageKO) {
        languageStr = "ko";
    }
    else if (language == HIVELanguage::HIVELanguagePT) {
        languageStr = "pt";
    }
    else if (language == HIVELanguage::HIVELanguageRU) {
        languageStr = "ru";
    }
    else if (language == HIVELanguage::HIVELanguageTH) {
        languageStr = "th";
    }
    else if (language == HIVELanguage::HIVELanguageTR) {
        languageStr = "tr";
    }
    else if (language == HIVELanguage::HIVELanguageVI) {
        languageStr = "vi";
    }
    else if (language == HIVELanguage::HIVELanguageZHS) {
        languageStr = "zh-hans";
    }
    else if (language == HIVELanguage::HIVELanguageZHT) {
        languageStr = "zh-hant";
    }

    jsonParam["language"] = picojson::value(languageStr);

    picojson::value resJson = HiveCppPlugin::callNative(jsonParam);

    PermissionViewData permissionViewData(resJson.get("data"));

    return permissionViewData;
}


void Configuration::executeEngine(picojson::value jsonParam)
{
	ResultAPI result;

}

NS_HIVE_END		// namespace hive



