

#include "HIVE_CppPlugin.h"


#include <string.h>
#include <string>

#if defined(ANDROID) || defined(__ANDROID__)
#include <jni.h>
#include <android/log.h>
#include <pthread.h>
#endif		// #if !defined(__OBJC__)

extern std::string HiveCPP_CallNative(std::string jsonParamString);

NS_HIVE_BEGIN

//TODO String Util 만들지.. 생각해봐야할듯 gnustl 에서 이상하게 std::to_string이 빠져있음.
//template <typename T>
std::string to_string(const long long value)
{
    //    std::ostringstream os ;
    char buf[100] = {0,};
    sprintf(buf, "%lld",value);

    return buf;
}

std::string to_string(const int value)
{
    char buf[100] = {0,};
    sprintf(buf, "%d",value);
    
    return buf;
}

std::string to_string(const double value)
{
    char buf[100] = {0,};
    sprintf(buf, "%f",value);
    
    return buf;
}

picojson::object HiveCppPlugin::createParam(std::string className, std::string methodName)
{
	picojson::object jsonParam;
	jsonParam["class"] = (picojson::value)className;
	jsonParam["method"] = (picojson::value)methodName;
	jsonParam["platform"] = (picojson::value)"cpp";
	return jsonParam;
}

picojson::value HiveCppPlugin::callNative(picojson::object jsonParam)
{
	std::string jsonParamString = picojson::value(jsonParam).serialize();
    return callNative(jsonParamString);
}
picojson::value HiveCppPlugin::callNative(std::string jsonParam) {
    std::string jsonParamString = jsonParam;
    std::string resJsonString = ::HiveCPP_CallNative(jsonParamString);
    
    picojson::value resJson;
    std::string err = picojson::parse(resJson, resJsonString);
    return resJson;
}

void HiveCppPlugin::callEngine(std::string jsonParamString)
{
    picojson::value jsonParam;
    std::string err = picojson::parse(jsonParam, jsonParamString);
    if(!err.empty())
    {
    	//return;
    }

    std::string className = jsonParam.get("class").to_str();
    std::string methodName = jsonParam.get("method").to_str();

    //CCLOG("class = %s, method = %s", className.c_str(), methodName.c_str());

    if(className.compare("Analytics") == 0)
    {
    	NS_HIVE::Analytics::executeEngine(jsonParam);
    }
    else if(className.compare("Configuration") == 0)
    {
    	NS_HIVE::Configuration::executeEngine(jsonParam);
    }
    else if(className.compare("Auth") == 0)
    {
    	NS_HIVE::Auth::executeEngine(jsonParam);
    }
    else if(className.compare("SocialHive") == 0)
    {
    	NS_HIVE::SocialHive::executeEngine(jsonParam);
    }
    else if(className.compare("SocialFacebook") == 0)
    {
    	NS_HIVE::SocialFacebook::executeEngine(jsonParam);
    }
    else if(className.compare("SocialGoogle") == 0)
    {
    	NS_HIVE::SocialGoogle::executeEngine(jsonParam);
    }
    else if(className.compare("Promotion") == 0)
    {
    	NS_HIVE::Promotion::executeEngine(jsonParam);
    }
    else if(className.compare("Push") == 0)
    {
    	NS_HIVE::Push::executeEngine(jsonParam);
    }
    else if(className.compare("IAP") == 0)
    {
    	NS_HIVE::IAP::executeEngine(jsonParam);
    }
    else if(className.compare("IAPV4") == 0)
    {
        NS_HIVE::IAPV4::executeEngine(jsonParam);
    }
	else if(className.compare("AuthV4") == 0)
	{
		NS_HIVE::AuthV4::executeEngine(jsonParam);
    }
    else if(className.compare("PlatformHelper") == 0) {
        NS_HIVE::PlatformHelper::executeEngine(jsonParam);
    }
    else if(className.compare("ProviderApple") == 0) {
        NS_HIVE::ProviderApple::executeEngine(jsonParam);
    }
    else if(className.compare("ProviderGoogle") == 0) {
        NS_HIVE::ProviderGoogle::executeEngine(jsonParam);
    }
    else if(className.compare("AuthV4Helper") == 0) {
        NS_HIVE::AuthV4::Helper::executeEngine(jsonParam);
    }
}

NS_HIVE_END		// namespace hive

#if defined(__OBJC__)

#include "HIVE_iOSPlugin.h"

//std::string HiveCPP_CallNative(std::string jsonParamString)
//{
//    std::string resJsonString = ::HivePlugin_callNative((char*)jsonParamString.c_str());
//    return resJsonString;
//}

#endif      // #if defined(__OBJC__)

#if defined(ANDROID)

#include "HIVE_JniHelper.h"

//static jobject g_javaObj;
//static HiveJniMethodInfo method;
//static JNIEnv* g_jniEnv = NULL;

extern "C" {

	JNIEXPORT void JNICALL Java_com_hive_plugin_HivePluginCpp_jniInitEngine(JNIEnv *env, jobject jobj)
	{
		jint rc = 0;
		JavaVM *javaVM = NULL;
    	rc = env->GetJavaVM(&javaVM);
		if (0 != rc) {
        	/* throw an exception  ... */
        	return;
    	}
		hive::HiveJniHelper::setJavaVM(javaVM);
	}

    JNIEXPORT void JNICALL Java_com_hive_plugin_HivePluginCpp_jniCallEngine(JNIEnv *env, jobject jobj, jstring target, jstring jsonParamJString)
    {
        //CCLOG("Java_com_hive_plugin_HivePluginCocos_jniCallEngine() Called");

        std::string jsonParamString = (char*)env->GetStringUTFChars(jsonParamJString, NULL);
        //CCLOG("jsonParamString = %s", jsonParamString.c_str());

        NS_HIVE::HiveCppPlugin::callEngine(jsonParamString);
    }

}		// extern "C" {
    
const char* PLUGIN_CLASS = "com/hive/plugin/HivePluginCpp";
std::string HiveCPP_CallNative(std::string jsonParamString)
{

	jclass cls;
	jmethodID methodId;
	JNIEnv *env = hive::HiveJniHelper::getEnv();
	if(env == NULL)
	{
		return "";
	}

	cls = env->FindClass(PLUGIN_CLASS);
	if (env->ExceptionCheck())
	{
        jthrowable exception = env->ExceptionOccurred();
        env->ExceptionDescribe();
        env->ExceptionClear();
        env->DeleteLocalRef(exception);
		return "";
	}

	methodId = env->GetStaticMethodID(cls, "callNative", "(Ljava/lang/String;)Ljava/lang/String;");
	if (env->ExceptionCheck())
	{
		jthrowable exception = env->ExceptionOccurred();
		env->ExceptionClear();
		env->DeleteLocalRef(exception);
		return "";
	}


	//CCLOG("jsonParamString = %s", jsonParamString.c_str());

	jstring stringArg = env->NewStringUTF((char*)jsonParamString.c_str());
	jstring resJsonJString = (jstring)env->CallStaticObjectMethod(cls, methodId, stringArg);
	env->DeleteLocalRef(stringArg);
	env->DeleteLocalRef(cls);


	//CCLOG("com/hive/plugin/HivePluginCocos.callNative() Called");

	std::string resJsonString = (char*)env->GetStringUTFChars(resJsonJString, NULL);
	env->DeleteLocalRef(resJsonJString);

	//CCLOG("resJsonString = %s", (const char*)resJsonString.c_str());

	return resJsonString;

}
#endif		//defined(ANDROID)





