


#include "HIVE_CppPlugin.h"



#if __cplusplus>=201103L
# include <cmath>
#else
extern "C" {
# ifdef _MSC_VER
#  include <float.h>
# elif defined(__INTEL_COMPILER)
#  include <mathimf.h>
# else
#  include <math.h>
# endif
}
#endif


#ifdef _MSC_VER
    #define SNPRINTF _snprintf_s
    #pragma warning(push)
    #pragma warning(disable : 4244) // conversion from int to char
    #pragma warning(disable : 4127) // conditional expression is constant
    #pragma warning(disable : 4702) // unreachable code
#else
    #define SNPRINTF snprintf
#endif

//static std::string ITOA(double number)
//{
//	char buf[256] = "";
//	double tmp;
//	SNPRINTF(buf, sizeof(buf), fabs(number) < (1ULL << 53) && modf(number, &tmp) == 0 ? "%.f" : "%.17g", number);
//
//	std::string retValue = buf;
//	return retValue;
//}


NS_HIVE_BEGIN


/// The max length of CCLog message.
static const int MAX_LOG_LENGTH = 16*1024;

static Logger::onLogger loggerListener = NULL;

void Logger::setLoggerListener(onLogger listener)
{
    loggerListener = listener;
}


void Logger::log(const char * format, ...)
{
    va_list args;
    va_start(args, format);

    char buf[MAX_LOG_LENGTH];
    
    vsnprintf(buf, MAX_LOG_LENGTH-3, format, args);
    strcat(buf, "\n");
    
    va_end(args);
    
    
    // Logger 에서 발생한 로그를 수신 받기 위한 리스너가 설정되어 있다면 로그를 전달해 준다.
    if(loggerListener != NULL)
        loggerListener("", "L", buf);
    
    
    picojson::object jsonParam = HiveCppPlugin::createParam("Logger", "log");
    jsonParam["tag"] = picojson::value("");
    jsonParam["level"] = picojson::value("L");
    jsonParam["msg"] = picojson::value(buf);
    
    HiveCppPlugin::callNative(jsonParam);
}

bool Logger::isActivateLogging() {
    
    picojson::object jsonParam = HiveCppPlugin::createParam("Logger", "isActivateLogging");
    picojson::value ret = HiveCppPlugin::callNative(jsonParam);
    bool bret = ret.get("isActivateLogging").get<bool>();
    return bret;
}


NS_HIVE_END		// namespace hive



