//
//  HIVE_PermissionVIew.cpp
//  HIVE_SDK_Plugin
//
//  Created by paikjongman on 12/12/2018.
//

#include <HIVE_PermissionView.h>
#include "HIVE_CppPlugin.h"
NS_HIVE_BEGIN

PermissionViewUnitData::PermissionViewUnitData()
{
    
}
PermissionViewUnitData::PermissionViewUnitData(picojson::value const& jsonParam)
{
    if(jsonParam.is<picojson::null>())
        return;
    
    HIVE_SETVALUEFROMJSONSTRING(this->contents, jsonParam, "contents");
    HIVE_SETVALUEFROMJSONSTRING(this->nativePermissionName, jsonParam, "nativePermissionName");
    HIVE_SETVALUEFROMJSONNUMBER(this->permissionCategory, PermissionViewPermissionCategory, jsonParam, "permissionCategory");
    HIVE_SETVALUEFROMJSONSTRING(this->title, jsonParam, "title");
}

PermissionViewData::PermissionViewData()
{
    
}
PermissionViewData::PermissionViewData(picojson::value const& jsonParam)
{
    if(jsonParam.is<picojson::null>())
        return;
    
    HIVE_SETVALUEFROMJSONSTRING(this->contents, jsonParam, "contents");
    
    auto tryJsonList = jsonParam.get("permissions");
    if(!tryJsonList.is<picojson::null>()) {
        auto jsonList = tryJsonList.get<picojson::array>();
        for(auto it=jsonList.begin();it!=jsonList.end();++it){
            auto unit = PermissionViewUnitData(*it);
            this->permissions.push_back(unit);
        }
    }

    auto commonJsonList = jsonParam.get("commons");
    if (!commonJsonList.is<picojson::null>()) {
        auto jsonList = commonJsonList.get<picojson::array>();
        for (auto it=jsonList.begin(); it!=jsonList.end(); ++it) {
            auto unit = PermissionViewUnitData(*it);
            this->commons.push_back(unit);
        }
    }
}
NS_HIVE_END		// namespace hive
