package com.hive.sample;

import java.util.HashMap;
import java.util.Map;

import com.hive.Analytics;




/**
 * Created by Hive Analytics Log System
 * 
 * @author ryuvsken
 */
public class AnalyticsLogAPI {

	
	/**
	 * 게임 가입 로그
	 * 
	 * @param userId		사용자 ID
	 * @param nickname		사용자 닉네임
	 */
	public static void Account_Join(String userId, String nickname) {
		
		Map<String, Object> logData = new HashMap<String, Object>();
		logData.put("category", "sdk_test_join"); // 가입
		logData.put("userid", userId);
		logData.put("nickname", nickname);
		Analytics.sendAnalyticsLog(logData);
	}
	
	
	/**
	 * 게임 로그인 로그
	 * 
	 * @param userId		사용자 ID
	 * @param currentGold	현재 보유 골드
	 */
	public static void Account_Login(String nickname, long currentGold) {
		
		Map<String, Object> logData = new HashMap<String, Object>();
		logData.put("category", "sdk_test_login");	// 로그인
		logData.put("nickname", nickname);
		logData.put("current_gold", currentGold);
		Analytics.sendAnalyticsLog(logData);
	}


	/**
	 * 계정 레벨업 로그
	 *
	 * @param level			현재(상승된) 레벨
	 */
	public static void Account_LevelUp(int level) {

		Map<String, Object> logData = new HashMap<String, Object>();
		logData.put("category", "hivesdk_levelup_log");
		logData.put("level", level);
		Analytics.sendAnalyticsLog(logData);
	}


	/**
	 * 캐릭터 뽑기 로그
	 *
	 * @param character
	 */
	public static void Account_CharacterGet(String character) {

		Map<String, Object> logData = new HashMap<String, Object>();
		logData.put("category", "hivesdk_character_get_log");
		logData.put("character", character);
		Analytics.sendAnalyticsLog(logData);
	}

	//Example Sandbox Server HIVE SDK Log Test
	public static void log_hivesdk_singular_normal_test(
//			int amountCurr,
//        int characterTypeId,
//        int characterId,
//        int accountLevel,
//        int assetId,
//        String itemName,
//        int amountVar,
//        int amountPrev,
//        int actionId,
//        int accountId,
//        String actionName,
//        String assetName,
//        int itemId,
//        int channelUid,
//        int characterLevel,
//        String extraLogBoby,
//        int amount_free_prev,
//        int amount_free_var,
//        int amount_free_curr,
//        int amount_paid_prev,
//        int amount_paid_var,
//        int amount_paid_curr,
//        int account_id,
//        int deviceid,
//        int isEmulator
	)
	{

		java.util.Map<String, Object> logData = new java.util.HashMap<String, Object>();
		logData.put("category", "hivesdk_asset_var_log");
		logData.put("amountCurr", 2 );
		logData.put("characterTypeId", 0 );
		logData.put("characterId", 4 );
		logData.put("accountLevel", 3);
		logData.put("assetId", 21 );
		logData.put("itemName", "item00000000000000000000000000" );
		logData.put("amountVar", 4 );
		logData.put("amountPrev", 3);
		logData.put("actionId", 5);
		logData.put("accountId", 13491024 );
		logData.put("actionName", "WAROFCLOUD" );
		logData.put("assetName", "PVPOPOWERWPOWEPRWER" );
		logData.put("itemId", 3398012 );
		logData.put("channelUid", 4809012 );
		logData.put("characterLevel", 8403);
		logData.put("extraLogBoby", "{'category','hivetest', 'level':10}" );
		logData.put("amount_free_prev", 1 );
		logData.put("amount_free_var", 1 );
		logData.put("amount_free_curr", 1 );
		logData.put("amount_paid_prev", 1 );
		logData.put("amount_paid_var", 1 );
		logData.put("amount_paid_curr", 1 );
		logData.put("account_id", 1 );
		logData.put("deviceid", 2 );
		logData.put("isEmulator", 0  );


		com.hive.Analytics.sendAnalyticsLog(logData);
	}



}
