package com.hive.sample;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

import org.json.JSONException;
import org.json.JSONObject;

import com.com2us.hivesdk.normal.freefull.google.global.android.common.R;
import com.hive.Auth;
import com.hive.Auth.Account;
import com.hive.PlatformHelper;
import com.hive.Promotion;
import com.hive.Promotion.AppInvitationCampaign;
import com.hive.Promotion.AppInvitationCampaignStage;
import com.hive.Promotion.AppInvitationData;
import com.hive.ResultAPI;
import com.hive.base.HttpClient;
import com.hive.base.HttpClient.HttpClientResponse;
import com.hive.base.HttpClient.HttpRequestListener;
import com.hive.impl.platformhelper.PlatformShare;

import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.net.Uri;
import android.os.Build;
import android.os.Environment;
import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TableLayout.LayoutParams;
import android.widget.TextView;
import android.widget.Toast;

import static androidx.core.content.FileProvider.getUriForFile;


/**
 * 프로모션의 앱 초대 데이터 조회 (Promotion.getAppInvitationData()) 의 결과를 화면에 보여주기 위한 테스트 대화 상자.
 * 
 * 앱 초대 데이터 정보는 앱 자신의 qrCode, inviteLink 정보등을 보함하고 있다.  
 * 
 * @author ryuvsken
 */
public class PromotionAppInvitationDataDialog extends Dialog {

	AppInvitationData info = null;
	
	ImageButton imagebutton_qrcode;
	TextView textview_commonlinkmsg;
	TextView textview_hivelinkmsg;
	TextView textview_facebooklinkmsg;
	TextView textview_inviteMessage;
	Button button_uaShare;
	ListView listview_each;
	ListView listview_stage;
	
	ListViewAdapter eachListView_adapter;
	ListViewAdapter stageListView_adapter;
	
	Bitmap qrcode;
	File qrcodeFile;
	
	File movieFile;
	
	//flag
	boolean isFileWriteSuccess = false;
	
	
	public PromotionAppInvitationDataDialog(final Context context, final AppInvitationData info) {
		super(context);
		
		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		
		setContentView(R.layout.test_view_promotion_appinvitation_result);
		
		if (context == null || info == null) {

			Toast.makeText(context, "Invalid Context of AcquisitionInfo!", Toast.LENGTH_SHORT).show();
		}
		
		imagebutton_qrcode = (ImageButton)findViewById(R.id.imagebutton_qrcode);
		textview_commonlinkmsg = (TextView)findViewById(R.id.textview_commonlinkmsg);
		textview_hivelinkmsg = (TextView)findViewById(R.id.textview_hivelinkmsg);
		textview_facebooklinkmsg = (TextView)findViewById(R.id.textview_facebooklinkmsg);
        textview_inviteMessage = (TextView)findViewById(R.id.textview_inviteMessagemsg);

        button_uaShare = findViewById(R.id.button_uaShare);
        button_uaShare.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {

				Promotion.showUAShare(textview_inviteMessage.getText().toString(), textview_hivelinkmsg.getText().toString(), new Promotion.PromotionShareListener() {
					@Override
					public void onPromotionShare(ResultAPI result) {

						Log.v("sample", (String.format("PromotionShareListener.onPromotionShare() Callback\nresult = %s\n", result.toString())));
					}
				});
			}
		});

		listview_each = (ListView)findViewById(R.id.listview_each);
		listview_stage = (ListView)findViewById(R.id.listview_stage);
		
		qrcode = BitmapFactory.decodeByteArray(info.qrcode, 0, info.qrcode.length);
//		qrcodeFile = new File(Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES), "qrcode.png");
		qrcodeFile = new File(context.getExternalFilesDir(Environment.DIRECTORY_PICTURES), "qrcode.png");

//		File imagePath = new File(Context.getFilesDir(), "images");
//		File newFile = new File(imagePath, "default_image.jpg");
		final Uri contentUri = getUriForFile(getContext(), context.getPackageName() + ".provider", qrcodeFile);

		Log.w("TESTLog","contentUri  =" + contentUri.toString());

		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(qrcodeFile);
			qrcode.compress(Bitmap.CompressFormat.PNG, 100, fos);
			isFileWriteSuccess = true;
		} catch (FileNotFoundException e) {
			isFileWriteSuccess = false;
			e.printStackTrace();
			Toast.makeText(context, "failed : gen QR code file.", Toast.LENGTH_SHORT).show();
		} finally {
			if(fos != null) try { fos.close(); } catch (IOException ignore) {}
		}


		final PlatformHelper.PlatformHelperListener listener = new PlatformHelper.PlatformHelperListener() {
			@Override
			public void onShare(Boolean isSuccess) {

				Log.v("sample", "[UASample] onShare:: isSuccess : " + isSuccess);
			}
		};


		imagebutton_qrcode.setImageBitmap(qrcode);
		imagebutton_qrcode.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				Log.v("sample", "[UASample] [ResultActivity] imagebutton_qrcode onClicked");
				
				ArrayList<String> mediaPaths = new ArrayList<String>();

				if(Build.VERSION.SDK_INT < Build.VERSION_CODES.M) {
					mediaPaths.add(Uri.fromFile(qrcodeFile).toString());
				}
				else {
					mediaPaths.add(contentUri.toString());
				}
				Log.v("sample", "mediaPaths.toString() : " + mediaPaths.toString());

				String paths[] = new String[mediaPaths.size()];
				paths = mediaPaths.toArray(paths);

				Log.v("sample", "paths.toString() : " + paths.toString());

//				PlatformHelper.shareMedia(paths, "See this QR Code!!", listener);

				PlatformShare platformShare = new PlatformShare();
				platformShare.setShareType(PlatformShare.SHARE_MEDIA);
				platformShare.setSubject("See this QR Code!!");
				platformShare.setMedia(paths);

				PlatformHelper.share(platformShare, listener);
			}

		});
		imagebutton_qrcode.setOnLongClickListener(new View.OnLongClickListener() {
			
			@Override
			public boolean onLongClick(View v) {
				Log.v("sample", "[UASample] [ResultActivity] imagebutton_qrcode onLongClicked");
				if(isFileWriteSuccess) {
					context.sendBroadcast(new Intent( Intent.ACTION_MEDIA_SCANNER_SCAN_FILE, Uri.fromFile(qrcodeFile)) );
					Toast.makeText(context, "QACode 이미지가 저장 되었습니다.", Toast.LENGTH_SHORT).show();
				} else {
					Toast.makeText(context, "QACode 이미지가 올바르지 않습니다.", Toast.LENGTH_SHORT).show();
				}
				return true;
			}
		});
		
		textview_commonlinkmsg.setText(info.inviteCommonLink);
		textview_commonlinkmsg.setTextColor(Color.BLUE);
		textview_commonlinkmsg.setOnTouchListener(new OnTouchListener() {
			
			@SuppressLint("ClickableViewAccessibility")
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				if (event.getAction() == MotionEvent.ACTION_UP) {
					Log.v("sample", "[UASample] [ResultActivity] textview_commonlinkmsg onTouch");
					
//					PlatformHelper.shareText(info.inviteCommonLink, listener);

					PlatformShare platformShare = new PlatformShare();
					platformShare.setShareType(PlatformShare.SHARE_TEXT);
					platformShare.setSubject(info.inviteMessage);
					platformShare.setText(info.inviteCommonLink);

					PlatformHelper.share(platformShare, listener);
					
					return false;
				} else return true;
			}
		});
		
		textview_hivelinkmsg.setText(info.inviteHivemsgLink);
		textview_hivelinkmsg.setTextColor(Color.BLUE);
		textview_hivelinkmsg.setOnTouchListener(new OnTouchListener() {
			
			@SuppressLint("ClickableViewAccessibility")
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				if (event.getAction() == MotionEvent.ACTION_UP) {
					Log.v("sample", "[UASample] [ResultActivity] textview_hivelinkmsg onTouch");
					
//					PlatformHelper.shareText(info.inviteHivemsgLink, listener);

					PlatformShare platformShare = new PlatformShare();
					platformShare.setShareType(PlatformShare.SHARE_TEXT);
					platformShare.setSubject(info.inviteMessage);
					platformShare.setText(info.inviteHivemsgLink);

					PlatformHelper.share(platformShare, listener);
					
					return false;
				} else return true;
			}
		});
		
		textview_facebooklinkmsg.setText(info.inviteFacebookLink);
		textview_facebooklinkmsg.setTextColor(Color.BLUE);
		textview_facebooklinkmsg.setOnTouchListener(new OnTouchListener() {
			
			@SuppressLint("ClickableViewAccessibility")
			@Override
			public boolean onTouch(View v, MotionEvent event) {
				if (event.getAction() == MotionEvent.ACTION_UP) {
					Log.v("sample", "[UASample] [ResultActivity] textview_facebooklinkmsg onTouch");
					
//					PlatformHelper.shareText(info.inviteFacebookLink, listener);

					PlatformShare platformShare = new PlatformShare();
					platformShare.setShareType(PlatformShare.SHARE_TEXT);
					platformShare.setSubject(info.inviteMessage);
					platformShare.setText(info.inviteFacebookLink);

					PlatformHelper.share(platformShare, listener);
					
					return false;
				} else return true;
			}
		});


		textview_inviteMessage.setText(info.inviteMessage);

		eachListView_adapter = new ListViewAdapter();
		stageListView_adapter = new ListViewAdapter();
		
		listview_each.setAdapter(eachListView_adapter);
		listview_stage.setAdapter(stageListView_adapter);
		
		for (AppInvitationCampaign campaign : info.eachCampaignList) {
			eachListView_adapter.add(campaign);
		}
		for (AppInvitationCampaignStage campaign : info.stageCampaignList) {
			stageListView_adapter.add(campaign);
		}
		
		listview_each.setLayoutParams(new LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, (100 * info.eachCampaignList.length) ));
		listview_stage.setLayoutParams(new LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, (100 * info.stageCampaignList.length) ));
	}
	
	
	@Override
	public void dismiss() {
		//TODO list bitmap recycle
		
//		if (qrcodeFile != null) qrcodeFile.delete();
//		if (qrcode != null) qrcode.recycle();
		
		super.dismiss();
	}
	
	
	private void startActionView(Context context, String uri) {
		Intent marketIntent = new Intent(Intent.ACTION_VIEW, Uri.parse(uri));
		marketIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		try {
			Toast.makeText(context, "Landing...", Toast.LENGTH_SHORT).show();
			context.startActivity(marketIntent);
		} catch (Exception ignore) {
			ignore.printStackTrace();
			Toast.makeText(context, "Landing Exception!", Toast.LENGTH_SHORT).show();
		}
	}
	
	class ListViewAdapter extends BaseAdapter {

		private ArrayList<AppInvitationCampaign> m_List;
		
		public ListViewAdapter() {
			m_List = new ArrayList<>();
		}
		
		@Override
		public int getCount() { return m_List.size(); }

		@Override
		public Object getItem(int position) { return m_List.get(position); }

		@Override
		public long getItemId(int position) { return position; }

		@Override
		public View getView(final int position, View convertView, ViewGroup parent) {
		    final Context context = parent.getContext();
		     
		    final AppInvitationCampaign campaign = m_List.get(position);
		    final ViewHolder holder;
		    
		    if ( convertView == null ) {
		        LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		        convertView = inflater.inflate(R.layout.test_view_promotion_appinvitation_campaign, parent, false);
		         
		        holder = new ViewHolder();
		        holder.imageview_img = (ImageView)convertView.findViewById(R.id.imageview_img);
		        holder.textview_title = (TextView)convertView.findViewById(R.id.textview_title);
		        holder.textview_desc = (TextView)convertView.findViewById(R.id.textview_desc);
		        holder.textview_count = (TextView)convertView.findViewById(R.id.textview_count);

		        convertView.setTag(holder);
		        
		    } else {
		        holder  = (ViewHolder) convertView.getTag();
		    }
		    
		    holder.textview_title.setText(campaign.title);
		    holder.textview_desc.setText(campaign.description);
		    holder.textview_count.setText(campaign instanceof AppInvitationCampaignStage
					? "보상 지급 수 : (" + campaign.count + "/" + campaign.limit + ")\n목표 달성 인원 : (" + ((AppInvitationCampaignStage)campaign).goalCount + "/" + ((AppInvitationCampaignStage) campaign).goalTotal + ")"
					: "캠페인 완료 인원 : (" + campaign.count + "/" + campaign.limit + ")");
		    
		    final StringBuilder builder = new StringBuilder();
		    JSONObject item = campaign.item;
		    if(item != null) {
		    	Iterator<String> itemKeys = item.keys();
		    	int i=0;
		    	while(itemKeys.hasNext()) {
		    		String key = itemKeys.next();
		    		if(i++!=0)builder.append("\n");
		    		builder.append(key).append(" ").append(item.opt(key));
		    	}
		    }
		    holder.rewardInfo = builder.toString();
		    
		    String vid = "";
		    
		    Account account = Auth.getAccount();
		    if (account != null)
		    	vid = account.vid;
		    
		    if (TextUtils.equals("레벨10 달성", campaign.title)) {
		    	holder.isCPA = true;
		    	holder.params.put("vid", vid);
		    	holder.params.put("action", "CPA_LEVEL_10");
		    } else if (TextUtils.equals("레벨20 달성", campaign.title)) {
		    	holder.isCPA = true;
		    	holder.params.put("vid", vid);
		    	holder.params.put("action", "CPA_LEVEL_20");
		    } else {
		    	holder.isCPA = false;
		    }
		    	
		    convertView.setOnClickListener(new View.OnClickListener() {
		         
		        @SuppressWarnings("deprecation")
				@Override
		        public void onClick(View v) {
		        	
	        		AlertDialog.Builder builder = new Builder(context);
	        		
	        		builder.setTitle(campaign.title + " 보상");
	        		builder.setMessage(holder.rewardInfo);
	        		builder.setInverseBackgroundForced(true);
	        		builder.setCancelable(true);
	        		builder.setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
	        			
	        			@Override
	        			public void onClick(DialogInterface dialog, int which) {
	        				dialog.cancel();
	        			}
	        		});
	        		
	        		if (holder.isCPA) {
		        		builder.setNegativeButton("CPA 완료하기", new DialogInterface.OnClickListener() {
							
							@Override
							public void onClick(DialogInterface dialog, int which) {
								
								Toast.makeText(context, campaign.title + " CPA 전송...", Toast.LENGTH_SHORT).show();
								
								
								// Map<String, String> params
					    		StringBuilder bodyBuilder = new StringBuilder();
					    		Iterator<Entry<String, String>> iterator = holder.params.entrySet().iterator();
					    		// constructs the POST body using the parameters
					    		while (iterator.hasNext()) {
					    			Entry<String, String> param = iterator.next();
					    			bodyBuilder.append(param.getKey()).append('=')
					    					.append(param.getValue());
					    			if (iterator.hasNext()) {
					    				bodyBuilder.append('&');
					    			}
					    		}
					    		String httpBody = bodyBuilder.toString();
								
								
								HttpClient httpClient = new HttpClient("http://test-misample.com2us.net/game/cpa");
								httpClient.requestHttp(httpBody, new HttpRequestListener() {
									
									@Override
									public void onHttpRequest(ResultAPI resultApi, HttpClientResponse httpClientResponse) {

										StringBuilder builder = new StringBuilder();
										builder.append("CPA 전송 ");
										if(resultApi.isSuccess()) {
											try {
												JSONObject o = new JSONObject(httpClientResponse.content);
												int resultCode = o.getInt("result_code");
												String resultMsg = o.optString("result_message");
												if(resultCode == 0) {
													builder.append("성공 : ").append(resultMsg);
												} else {
													builder.append("실패 : ").append(resultMsg);
												}
											} catch (JSONException ignore) {
												builder.append("실패 : ").append(ignore.toString());
											}
										} else {
											builder.append("실패 : ").append(resultApi);
										}
										
										Toast.makeText(context, builder.toString(), Toast.LENGTH_LONG).show();
									}
								});
								
							}
						});
	        		}
	        		builder.setOnCancelListener(new DialogInterface.OnCancelListener() {
	        			
	        			@Override
	        			public void onCancel(DialogInterface dialog) {
	        				dialog.dismiss();
	        			}
	        		});
	        		builder.create().show();
		        	
		        }
		    });
		     
		    return convertView;
		}
		
	    public void add(AppInvitationCampaign campaign) { m_List.add(campaign); }
	     
	    public void remove(int position) { m_List.remove(position); }
		
	}
	
	
	class ViewHolder {
		ImageView imageview_img;
	    TextView textview_title;
	    TextView textview_desc;
	    TextView textview_count;
	    String rewardInfo;
	    boolean isCPA = false;
	    Map<String, String> params = new HashMap<String, String>();
	}
	

}
