package com.hive.sample.game;

import android.os.Handler;
import android.os.Looper;
import android.text.TextUtils;

public class GameUser {

	public String sessionToken; //that's mean game session token. not lc_session(loginCenter)
	public String nickname;
	public int gold;
	public int gem;
	public String subscrptionMarketPid;
	
	public boolean isLogin = false;

	private static GameUser gameUser;
	
	private GameUser() {}
	
	public static GameUser getInstance() {
		if(gameUser == null) {
			synchronized (GameUser.class) {
				gameUser = new GameUser();
			}
		}
		return gameUser;
	}
	
	
	public void login(final IGameListener listener) {
		
		GameNetwork.login(new IGameListener() {
			
			@Override
			public void onGameListener(boolean result, Response response) {

				if(result && response != null && response.isSuccess()) {
					
					if( reflesh(response) ) {
						
						if(listener != null) listener.onGameListener(true, response);
						return;
					}
				}
					
				if(listener != null) listener.onGameListener(false, null);
			}
		});
	}
	
	public void logout(final IGameListener listener) {
		
		sessionToken = null;
		nickname = null;
		gold = -1;
		gem = -1;
		subscrptionMarketPid = null;
		
		isLogin = false;
		
		new Handler(Looper.getMainLooper()).post(new Runnable() {
			
			@Override
			public void run() {
				
				if(listener != null) listener.onGameListener(true, null);
			}
		});
	}
	
	
	public void update(final IGameListener listener) {
		
		GameNetwork.userInfo(new IGameListener() {
			
			@Override
			public void onGameListener(boolean result, Response response) {

				if(result && response != null && response.isSuccess()) {
					
					if( reflesh(response) ) {
						
						if(listener != null) listener.onGameListener(true, response);
						return;
					}
				}
					
				if(listener != null) listener.onGameListener(false, null);
				
			}
		});
		
	}
	
	
	protected boolean reflesh(Response response) {
		
		if(response != null) {
			
			try {
				sessionToken = TextUtils.isEmpty(response.sessionToken) ? sessionToken : response.sessionToken;
				nickname = response.resultData.optString("nickname");
				gold = response.resultData.optInt("gold");
				gem = response.resultData.optInt("gem");
				
				isLogin = !TextUtils.isEmpty(sessionToken);
				
				return true;
				
			} catch (Exception ignore) {
				return false;
			}
			
		} else return false;
	}
	
}
