package com.hive.sample.game;

import android.content.Context;
import android.os.Handler;
import android.os.Looper;
import android.widget.Toast;

import com.hive.sample.IAPTestView;
import com.hive.sample.IAPV4TestView;
import com.hive.sample.game.GamePostboxDialog;
import com.hive.sample.game.GameUser;
import com.hive.sample.game.IGameListener;
import com.hive.sample.game.Response;


// Only for Unity3D IAP sample 
public class PostBox {
	
	private static PostBox PostBoxImpl = new PostBox();
	
	public static PostBox instance () {
		return PostBoxImpl;
	}
	
	public static void showPostBox(final Context context) {
		
		if(GameUser.getInstance().isLogin) {
			
			new Handler(Looper.getMainLooper()).post(new Runnable() {
				
				@Override
				public void run() {
					IAPTestView iapTestView = null;
					GamePostboxDialog gamePostboxDialog = new GamePostboxDialog(context, iapTestView);
					gamePostboxDialog.show();
				}
			});
			
		}
		
		else {
			
			GameUser.getInstance().login(new IGameListener() {
				
				@Override
				public void onGameListener(boolean result, Response response) {
					
					if(result && response.isSuccess()) {
						
						new Handler(Looper.getMainLooper()).post(new Runnable() {
							
							@Override
							public void run() {
								
//								onGameUserUiUpdate();

								IAPTestView iapTestView = null;
								GamePostboxDialog gamePostboxDialog = new GamePostboxDialog(context, iapTestView);
								gamePostboxDialog.show();
							}
						});
					} 
					
					else {
						
						String msg = "Postbox Error : GameUser Login Failed.";
						Toast.makeText(context, msg, Toast.LENGTH_LONG).show();
					}
					
				}
			});
		}
	}
}
