package com.hive.sample.game;

import org.json.JSONException;
import org.json.JSONObject;

import android.text.TextUtils;

public class Response {
	
	public String resultCode;
	public String resultMsg;
	public JSONObject resultData;
	public String sessionToken;
	
	public String originalData;

	public Response(String responseData) throws JSONException {
		
		if( TextUtils.isEmpty(responseData) ) 
			throw new JSONException("post data is null");
		
		originalData = responseData;
		JSONObject o = new JSONObject(originalData);
		
		resultCode = o.getString("result_code");
		resultMsg = o.optString("result_msg");
		resultData = o.optJSONObject("result_data");
		sessionToken = o.optString("session_token");
	}
	
	public boolean isSuccess() { return TextUtils.equals(resultCode, "200"); }
	public boolean isFailure() { return !isSuccess(); }
	
	@Override
	public String toString() {
		return originalData;
	}

}
