package com.hive.sample.uihelper;


/**
 * @author hife
 */
public interface HiveImageLoadingListener {
	
	/**
	 * Is called when an error was occurred during image loading
	 *
	 * @param url Loading image URL
	 * @param failReason why image loading was failed
	 */
	void onLoadingFailed(String url, String failReason);

	/**
	 * Is called when image loading success
	 * 
	 * @param url Loading image URL
	 * @param data downloaded original raw data
	 */
	void onLoadingComplete(String url, byte[] data);
}
