/**
 * 
 */
package com.hive.sample.uihelper;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import android.app.Dialog;
import android.content.Context;
import android.os.Build;
import android.os.Bundle;
import android.util.Pair;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.EditorInfo;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.ToggleButton;

/**
 * @author Red
 *
 */
public class SelectDialog extends Dialog
{

	/**
	 * @param context
	 */
	public SelectDialog(Context context) {
		super(context);// , R.style.Theme_Dialog);

	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		Context context = getContext();


		LinearLayout dialogLayout = new LinearLayout(context);// 상중하 3등분
		dialogLayout.setOrientation(LinearLayout.VERTICAL);
		// dialogLayout.setWeightSum(100);


		if (titleString != null) {
			// 상단타이틀
			TextView titleText = new TextView(context);
			titleText.setText(titleString);
			dialogLayout.addView(titleText, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT));
		}
		// 중앙
		// 입력
		inputLayout = new LinearLayout(context);
		inputLayout.setPadding(50, 50, 50, 50);
		inputLayout.setOrientation(LinearLayout.VERTICAL);
		inputLayout.setScrollContainer(true);
		for (ViewGroup v : layoutViewList) {
			v.setEnabled(false);
			inputLayout.addView(v, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT));
		}
		dialogLayout.addView(inputLayout, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT));


		// 하단
		// 버튼들.
		buttonLayout = new LinearLayout(context);
		buttonLayout.setOrientation(LinearLayout.HORIZONTAL);
		buttonLayout.setWeightSum(3);

		cancelButton = new Button(context);
		cancelButton.setText("cancel");
		cancelButton.setOnClickListener(clickListener);
		buttonLayout.addView(cancelButton, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 1));

		prevButton = new Button(context);
		prevButton.setText("prev");
		prevButton.setOnClickListener(clickListener);
		buttonLayout.addView(prevButton, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 1));

		// DummyArea
		dummyView = new View(context);
		buttonLayout.addView(dummyView, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 1));

		nextButton = new Button(context);
		nextButton.setText("next");
		nextButton.setOnClickListener(clickListener);
		buttonLayout.addView(nextButton, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 1));

		finshButton = new Button(context);
		finshButton.setText("finish");
		finshButton.setOnClickListener(clickListener);
		buttonLayout.addView(finshButton, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 1));

		dialogLayout.addView(buttonLayout, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT));

		setContentView(dialogLayout, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT));

		updateLayout();

		// titleText.setBackgroundColor(Color.BLACK);
		// inputLayout.setBackgroundColor(Color.YELLOW);
		// cancelButton.setBackgroundColor(Color.CYAN);// for Debug
		// prevButton.setBackgroundColor(Color.BLUE);// for Debug
		// dummyView.setBackgroundColor(Color.RED);// for Debug
		// nextButton.setBackgroundColor(Color.GREEN);// for Debug
		// finshButton.setBackgroundColor(Color.MAGENTA);// for Debug
	}

	class InputContent extends LinearLayout
	{

		/**
		 * @param context
		 */
		public InputContent(Context context, String key, View content) {
			super(context);
			// TODO Auto-generated constructor stub
			keyTextView = new TextView(context);
			keyTextView.setText(key);

			input = content;

			setOrientation(LinearLayout.HORIZONTAL);
			addView(keyTextView, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.WRAP_CONTENT, 0.3f));
			addView(content);
		}

		/*
		 * (non-Javadoc)
		 * 
		 * @see android.view.ViewGroup#onLayout(boolean, int, int, int, int)
		 */
		@Override
		protected void onLayout(boolean changed, int l, int t, int r, int b) {

			// TODO Auto-generated method stub
			super.onLayout(changed, l, t, r, b);
		}

		TextView	keyTextView;
		View		input;
	}

	private OnDialogResultListener	resultCallback;
	private String			titleString	= null;

	private LinearLayout	inputLayout;
	private List<InputContent>		layoutViewList	= new LinkedList<InputContent>();
	private int				inputIndex	= 0;

	private LinearLayout	buttonLayout;
	private Button			cancelButton;
	private Button			prevButton;
	private View			dummyView;
	private Button			nextButton;
	private Button			finshButton;


	public void addInputContent(String key, View v) {

		InputContent itemLayout = new InputContent(getContext(), key, v);

		layoutViewList.add(itemLayout);
	}

	public void setTitle(String titleString) {

		this.titleString = titleString;
	}

	public void setDialogResultListener(OnDialogResultListener listener) {

		this.resultCallback = listener;
	}

	private View.OnClickListener clickListener = new View.OnClickListener() {

		@Override
		public void onClick(View v) {

			inputLayout.getChildAt(inputIndex).setEnabled(false);

			if (v == cancelButton)
				inputIndex--;
			else if (v == prevButton)
				inputIndex--;
			else if (v == nextButton)
				inputIndex++;
			else if (v == finshButton)
				inputIndex++;
			updateLayout();
		}
	};

	private void updateLayout() {

		int childCount = inputLayout.getChildCount();
		if (inputIndex == childCount) {
			if( resultCallback != null )
			{
				Map<String, Object> result = new HashMap<String, Object>();
				for (InputContent ic : layoutViewList) {
					String key = ic.keyTextView.getText().toString();
					View v = ic.input;
					if (v instanceof EditText) {
						EditText editText = (EditText) v;
						result.put(key, editText.getText().toString());
					}
					else if (v instanceof Spinner) {
						Spinner spinText = (Spinner) v;
						result.put(key, spinText.getSelectedItem().toString());
					}
					else if (v instanceof ToggleButton) {
						ToggleButton tb = (ToggleButton) v;
						result.put(key, tb.isChecked() ? Boolean.TRUE : Boolean.FALSE);
					}
				}
				resultCallback.onDialogResult(true, result);
			}
			dismiss();
		}
		else if (inputIndex < 0) {
			if (resultCallback != null)
				resultCallback.onDialogResult(false, null);
			cancel();
		}
		else {

			if (inputIndex == 0) {
				// hide prev & show cancel
				prevButton.setVisibility(View.GONE);
				cancelButton.setVisibility(View.VISIBLE);
			}
			else {
				// show prev & hide cancel
				prevButton.setVisibility(View.VISIBLE);
				cancelButton.setVisibility(View.GONE);
			}

			if (inputIndex + 1 == childCount) {
				// show finish & hide next
				nextButton.setVisibility(View.GONE);
				finshButton.setVisibility(View.VISIBLE);
			}
			else {
				// show next & hide finish
				nextButton.setVisibility(View.VISIBLE);
				finshButton.setVisibility(View.GONE);
			}

			View nextInput = inputLayout.getChildAt(inputIndex);
			nextInput.setEnabled(true);
			nextInput.requestFocus();

			inputLayout.invalidate();
			buttonLayout.invalidate();
		}
	}

	public interface OnDialogResultListener
	{
		void onDialogResult(boolean completed, Map<String, Object> result);
	}


	public static class Builder
	{
		private Context context;
		private LinkedList<Pair<String, Object>>	inputList	= new LinkedList<Pair<String, Object>>();
		private String								titleString;
		private OnDialogResultListener				listener;

		public Builder(Context context) {
			this.context = context;
		}

		public Builder addInputText(String key) {

			inputList.add(new Pair<String, Object>(key, null));
			return this;
		}

		public Builder addInputText(String key, String defaultValue) {

			inputList.add(new Pair<String, Object>(key, defaultValue));
			return this;
		}

		public Builder addSelectList(String key, List<String> selectList) {

			inputList.add(new Pair<String, Object>(key, selectList.toArray()));
			return this;
		}

		public Builder addSelectList(String key, String[] selectList) {

			inputList.add(new Pair<String, Object>(key, selectList));
			return this;
		}

		public Builder addSwitch(String key, boolean defaultValue) {

			inputList.add(new Pair<String, Object>(key, Boolean.valueOf(defaultValue)));
			return this;
		}

		public Builder setTitle(String titleString) {

			this.titleString = titleString;
			return this;
		}

		public Builder setDialogResultListener(OnDialogResultListener listener) {

			this.listener = listener;
			return this;
		}

		public SelectDialog autobuild(Class<?> buildType) {

			if (this.titleString == null)
				setTitle(buildType.getSimpleName());

			java.lang.reflect.Field[] memberFields = buildType.getFields();

			for (java.lang.reflect.Field field : memberFields) {
				try {
					// if value == null , don't put it. cause make "null" string
					String name = field.getName();
					Class<?> type = field.getType();
					
					if( type.isEnum() )
					{
						Class<? extends Enum> enumType = (Class<? extends Enum>) type;
						
						Enum[] enumValues = enumType.getEnumConstants();
						List<String> enumValueNames = new ArrayList<String>();
						for (Enum enumValue : enumValues)
						{
							enumValueNames.add(enumValue.name());

						}
						addSelectList(name, enumValueNames);
					}
					else if (type == Boolean.class) {
						addSwitch(name, false);
					}
					else {
						addInputText(name);
					}

				}
				catch (IllegalArgumentException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			return build();
		}

		public SelectDialog build() {

			SelectDialog dialog = new SelectDialog(context);

			if (inputList.size() == 0)
				return dialog;
			else
			{

				Pair<String, Object> step = inputList.poll();
				while (step != null) {

					if (step.second == null) {
						// InputText
						EditText inputText = new EditText(context);
						inputText.setInputType(EditorInfo.TYPE_TEXT_FLAG_NO_SUGGESTIONS);
						inputText.setHint(step.first);
						dialog.addInputContent(step.first, inputText);
					}
					else if (step.second instanceof String) {
						EditText inputText = new EditText(context);
						inputText.setInputType(EditorInfo.TYPE_TEXT_FLAG_NO_SUGGESTIONS);
						inputText.setHint((String) step.second);
						dialog.addInputContent(step.first, inputText);
					}
					else if (step.second instanceof String[]) {
						// SelectInput
						String[] list = (String[]) step.second;
						ArrayAdapter<String> spAdapter = new ArrayAdapter<String>(context, android.R.layout.simple_spinner_item);
						spAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
						if (Build.VERSION.SDK_INT > Build.VERSION_CODES.HONEYCOMB)
							spAdapter.addAll(list);
						else
						{
							for (String item : list)
								spAdapter.add(item);
						}

						Spinner spinText = new Spinner(context);
						spinText.setAdapter(spAdapter);
						spinText.setSelection(0);
						spinText.setPrompt(step.first);
						dialog.addInputContent(step.first, spinText);

					}
					else if (step.second instanceof Boolean) {
						ToggleButton tb = new ToggleButton(context);
						tb.setText(step.first);
						tb.setChecked((Boolean) step.second);
						dialog.addInputContent(step.first, tb);
					}

					step = inputList.poll();
				}

				dialog.setTitle(titleString);
				dialog.setDialogResultListener(listener);

				if (Build.VERSION.SDK_INT >= 21)
					dialog.create();
				return dialog;
			}
		}
	}

	// N개의 텍스트입력 혹은 콤보박스 선택입력을 이전< , 다음> or 완성 & 취소
	// 프리뷰를 실시간 혹은 입력후 선택.

}



